import SystemBase from "../../extensions/ngame/assets/ngame/system/SystemBase";
import { app } from "./App";
import BaseData from "./data/BaseData";
import ChatData from "./data/ChatData";
import GOnHookData from "./data/GOnHookData";
import PlayerData from "./data/PlayerData";
import PlayerPetData from "./data/PlayerPetData";
import PlayerTacticalData from "./data/PlayerTacticalData";
import ResourceData from "./data/ResourceData";

//数据类 (用于初始化游戏信息)
export class AppData extends SystemBase{

    static loading = "AppData";

    loadings:BaseData[] = [
        PlayerData.getIns(), //玩家信息
        PlayerPetData.getIns(), //玩家宠物信息
        ChatData.getIns(), //聊天
        PlayerTacticalData.getIns(), //阵法
        ResourceData.getIns(), //玩家资源
        GOnHookData.getIns(),   //无限模式信息类 (无限模式是游戏基础模式玩法 需要默认信息)
    ];
    
    async onInit(): Promise<any> {
        
        app.loading.setCurrent(AppData.loading);

        //初始化所有数据类
        for (let index = 0; index < this.loadings.length; index++) {
            const data = this.loadings[index];
            await data.onInit();
        }

        app.loading.ok(AppData.loading);

    }

}

