import { _decorator, Component, director, instantiate, Node, Prefab } from 'cc';
import { app } from './App';
import { JNGame } from '../../extensions/ngame/assets/ngame/JNGame';
import { JNSyncAction } from '../../extensions/ngame/assets/ngame/sync/JNSyncAction';
import { GOnHookPets } from '../../extensions/ngame/assets/ngame/message/proto';
import { Env, EnvCurrent } from './Env';
import { GAction } from './consts/GAction';
const { ccclass, property } = _decorator;

window['GUser'] = "100000";
window['GPassworld'] = "123456";

@ccclass('Main')
export class Main extends Component {

    @property(Prefab)
    UIPrefab: Prefab = null;

    @property(Prefab)
    WorldPrefab: Prefab = null;

    async onLoad(){

        console.log("EnvCurrent",EnvCurrent)

        // 创建UI
        director.getScene().addChild(instantiate(this.UIPrefab));

        //加载 APP
        await JNGame.Init(app);

        // //发生帧同步开始
        // app.socket.Send(JNSyncAction.NSyncFrameStart);

        // 创建世界
        director.getScene().addChild(instantiate(this.WorldPrefab));

        if(EnvCurrent == Env.Server){
            //发送就绪
            app.socket.Send(GAction.CR_REFEREE_READY);
        }

    }

}


