package cn.jisol.game.controller.game;

import cn.jisol.game.controller.argsresolver.CurrentPlayer;
import cn.jisol.game.entity.game.Player;
import cn.jisol.game.entity.game.PlayerPet;
import cn.jisol.game.entity.game.PlayerTactical;
import cn.jisol.game.service.PlayerPetService;
import cn.jisol.game.service.PlayerTacticalService;
import cn.jisol.ngame.util.NewsContext;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Objects;

/**
 * 玩家阵法
 */
@Api(value = "JNGameDemo - API", tags = {"PET - API"})
@RestController
@RequestMapping("/game/tactical")
@ResponseBody
public class GPlayerTacticalController {

    @Autowired
    PlayerTacticalService playerTacticalService;

    //默认阵法
    public final String InitTactical = "[0,0,0,0,0,0,0,0,0]";

    //获取玩家阵法
    @ApiImplicitParams({})
    @ApiOperation(value = "获取玩家阵法")
    @GetMapping("/get")
    public NewsContext<PlayerTactical> getInfo(@CurrentPlayer Player player){

        PlayerTactical info = playerTacticalService.getById(player.getPlayerId());

        //如果没有阵法则创建一个
        if(Objects.isNull(info)){
            try{
                info = PlayerTactical.builder().playerId(player.getPlayerId()).build();
                playerTacticalService.saveOrUpdate(info);
            }catch (Exception ignored){}
            assert playerTacticalService != null;
            info = playerTacticalService.getById(player.getPlayerId());
        }

        //如果没有阵法则默认一个阵法
        if(Objects.isNull(info.getTacticalData())){
            info.setTacticalData(InitTactical);
        }

        return NewsContext.onSuccess("获取成功",info);

    }

    //设置玩家上阵
    @ApiImplicitParams({})
    @ApiOperation(value = "设置玩家上阵")
    @PostMapping("/set")
    public NewsContext<PlayerTactical> setInfo(@CurrentPlayer Player player, @RequestBody PlayerTactical tactical){

        tactical.setPlayerId(player.getPlayerId());
        if(Objects.isNull(tactical.getTacticalData())) return NewsContext.onFail("上阵失败 没有上阵信息");
        playerTacticalService.saveOrUpdate(tactical);

        return NewsContext.onSuccess("上阵成功",tactical);

    }

}
