package cn.jisol.game.controller.game;

import cn.jisol.game.controller.argsresolver.CurrentPlayer;
import cn.jisol.game.entity.game.Player;
import cn.jisol.game.entity.game.PlayerTactical;
import cn.jisol.game.entity.game.Resource;
import cn.jisol.game.service.ResourceService;
import cn.jisol.ngame.util.NewsContext;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import java.sql.Wrapper;
import java.util.List;

/**
 * 资源
 */
@Api(value = "JNGameDemo - API", tags = {"资源 - API"})
@RestController
@RequestMapping("/game/resource")
@ResponseBody
public class GResourceController {

    @Autowired
    ResourceService resourceService;

    //获取玩家的资源
    @ApiImplicitParams({})
    @ApiOperation(value = "获取玩家的资源")
    @GetMapping("/get")
    public NewsContext<List<Resource>> getInfo(@CurrentPlayer Player player){

        //获取玩家全部资源列表
        List<Resource> list = resourceService.list(
                Wrappers.lambdaQuery(Resource.class)
                        .eq(Resource::getPlayerId, player.getPlayerId())
        );

        return NewsContext.onSuccess("获取成功",list);

    }

}
